//
//  TestViewController.m
//  RunLoopAndTimer
//
//  Created by WuChuMing on 2020/1/7.
//  Copyright © 2020 Shawn. All rights reserved.
//

#import "TestViewController.h"
#import "SDWeakProxy.h"

@interface TestViewController ()

@property (nonatomic, strong) UIScrollView *scrollView;

@property (nonatomic, strong) NSTimer *testTimer;

@property(nonatomic, strong)dispatch_source_t connectTimer;

@property (nonatomic, strong) UILabel *rateL;

@end

@implementation TestViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    UIEdgeInsets safeEdge = [UIApplication sharedApplication].delegate.window.safeAreaInsets;
    NSLog(@"----viewdidLoad----timer----->%@",_testTimer);
    CGFloat top = safeEdge.top;
    CGFloat left = safeEdge.left;
    CGSize size = [UIScreen mainScreen].bounds.size;
    CGFloat width = size.width - left - safeEdge.right;
    CGFloat height = size.height - top - safeEdge.bottom;
    CGRect avalibleFrame = CGRectMake(left, top, width, height);
    _scrollView = [[UIScrollView alloc] initWithFrame:avalibleFrame];
    [self.view addSubview:_scrollView];
    
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    button.frame = CGRectMake(100, top, 100, 30);
    button.backgroundColor = [UIColor blueColor];
    [button setTitle:@"Dismiss" forState:0];
    [button addTarget:self action:@selector(_buttonClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:button];
    switch (_type) {
        case K_VcType_runLoop:
            [self _observerTest];
            break;
        case K_VcType_Timer:
            [self _timerTest];
            break;
        case K_VcType_Link:
            [self _linkTest];
            break;
        case K_VcType_dispatch:
            [self _dispatchTest];
            break;
        case K_VcType_timeRecord:
            [self _add3Timer];
            break;
        default:
            break;
    }
    // Do any additional setup after loading the view.
}

#pragma mark ----创建方法----

- (void)_add3Timer{
//   普通的计时器
    self.scrollView.contentSize = CGSizeMake([UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height*200);
    
    for (NSInteger i = 0; i < 100; i ++) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
       button.frame = CGRectMake(100, 100 + i * 40, 100, 30);
        button.backgroundColor = [self RandomColor];
       [button addTarget:self action:@selector(_buttonClick2:) forControlEvents:UIControlEventTouchUpInside];
        [self.scrollView addSubview:button];
        
        UIButton *button2 = [UIButton buttonWithType:UIButtonTypeCustom];
         button2.frame = CGRectMake(250, 100 + i * 40, 100, 30);
        button2.backgroundColor = [self RandomColor];
         [button2 addTarget:self action:@selector(_buttonClick2:) forControlEvents:UIControlEventTouchUpInside];
          [self.scrollView addSubview:button2];
    }
    
    
    
    __weak typeof(self) weakSelf = self;
    SDWeakProxy *weakProxy = [SDWeakProxy proxyWithTarget:self];
    self.testTimer = [NSTimer scheduledTimerWithTimeInterval:1 target:weakProxy selector:@selector(_recordTimer) userInfo:nil repeats:YES];
    [[NSRunLoop currentRunLoop] addTimer:self.testTimer forMode:NSRunLoopCommonModes];
//   屏幕刷屏计时器
     CADisplayLink *displayLink = [CADisplayLink displayLinkWithTarget:weakProxy selector:@selector(_recordLink)];
    displayLink.preferredFramesPerSecond = 1;
    [displayLink addToRunLoop:[NSRunLoop currentRunLoop] forMode:NSRunLoopCommonModes];
//  GCD计时器
    dispatch_queue_t queue = dispatch_get_main_queue();
    self.connectTimer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, queue);
    //开始时间
    dispatch_time_t start = dispatch_time(DISPATCH_TIME_NOW, 0 * NSEC_PER_SEC);
    //间隔时间
    uint64_t interval = 1.0 * NSEC_PER_SEC;
    dispatch_source_set_timer(self.connectTimer, start, interval, 0);
    //设置回调
    dispatch_source_set_event_handler(self.connectTimer, ^{
        [weakSelf _recordGCD];
    });
    dispatch_resume(self.connectTimer);
    
}

- (void)_buttonClick2:(UIButton *)btn{
    for (UIButton *button in self.scrollView.subviews) {
        if ([button isKindOfClass:[UIButton class]]) {
            button.backgroundColor = [self RandomColor];
        }
    }
}

- (UIColor*)RandomColor {
  NSInteger aRedValue =arc4random() %255;
 NSInteger aGreenValue =arc4random() %255;
 NSInteger aBlueValue =arc4random() %255;
 UIColor*randColor = [UIColor colorWithRed:aRedValue /255.0f green:aGreenValue /255.0f blue:aBlueValue /255.0f alpha:1.0f];
  return randColor;
\
}

- (void)_dispatchTest{
    dispatch_queue_t queue = dispatch_get_main_queue();
    self.connectTimer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, queue);
    //开始时间
    dispatch_time_t start = dispatch_time(DISPATCH_TIME_NOW, 0.0 * NSEC_PER_SEC);
    //间隔时间
    uint64_t interval = 1.0 * NSEC_PER_SEC;
    dispatch_source_set_timer(self.connectTimer, start, interval, 0);
    //设置回调
    dispatch_source_set_event_handler(self.connectTimer, ^{
        [self _doFireTimer];
    });
     dispatch_resume(self.connectTimer);
}



- (void)_observerTest {
    __weak typeof(self) weakSelf = self;
//    dispatch_async(dispatch_get_global_queue(0, 0), ^{
        /**
         param1: 给observer分配存储空间
         param2: 需要监听的状态类型:kCFRunLoopAllActivities监听所有状m 态
         param3: 是否每次都需要监听，如果NO则一次之后就被销毁，不再监听，类似定时器的是否重复
         param4: 监听的优先级，一般传0
         param5: 监听到的状态改变之后的回调
         return: 观察对象
         */
        CFRunLoopObserverRef  observer = CFRunLoopObserverCreateWithHandler(CFAllocatorGetDefault(), kCFRunLoopAllActivities, YES, 0, ^(CFRunLoopObserverRef observer, CFRunLoopActivity activity) {
            switch (activity) {
                case kCFRunLoopEntry:
                    NSLog(@"即将进入runloop");
                    break;
                case kCFRunLoopBeforeTimers:
                    NSLog(@"即将处理timer---%@", weakSelf.testTimer );
                    break;
                case kCFRunLoopBeforeSources:
                    NSLog(@"即将处理input Sources");
                    break;
                case kCFRunLoopBeforeWaiting:
                    NSLog(@"即将睡眠");
                    break;
                case kCFRunLoopAfterWaiting:
                    NSLog(@"从睡眠中唤醒，处理完唤醒源之前");
                    break;
                case kCFRunLoopExit:
                    NSLog(@"退出");
                    break;
                default:
                    break;
            }
        });
        CFRunLoopAddObserver([[NSRunLoop currentRunLoop] getCFRunLoop], observer, kCFRunLoopCommonModes);
//    });
//    dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0)
       dispatch_queue_t queue = dispatch_get_main_queue();
       weakSelf.connectTimer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0, queue);
       //开始时间
       dispatch_time_t start = dispatch_time(DISPATCH_TIME_NOW, 1.0 * NSEC_PER_SEC);
       //间隔时间
       uint64_t interval = 0.0 * NSEC_PER_SEC;
       dispatch_source_set_timer(weakSelf.connectTimer, start, interval, 0);
       //设置回调
       dispatch_source_set_event_handler(weakSelf.connectTimer, ^{
       
           [weakSelf _doFireTimer];
       });
        dispatch_resume(weakSelf.connectTimer);
   
}

- (void)_timerTest{
      SDWeakProxy *weakProxy = [SDWeakProxy proxyWithTarget:self];
       self.testTimer = [NSTimer scheduledTimerWithTimeInterval:1 target:weakProxy selector:@selector(_doFireTimer) userInfo:nil repeats:YES];
}

- (void)_linkTest{
    SDWeakProxy *weakProxy = [SDWeakProxy proxyWithTarget:self];
     CADisplayLink *displayLink = [CADisplayLink displayLinkWithTarget:weakProxy selector:@selector(_doFireTimer)];
    displayLink.preferredFramesPerSecond = 1;
    [displayLink addToRunLoop:[NSRunLoop currentRunLoop] forMode:NSRunLoopCommonModes];
}


static int count = 0;
#define LHeight 30

- (void)_doFireTimer {
    NSLog(@"----------timer----------->");
    for (NSInteger i = 0; i < 1000 ; i ++) {
         NSObject *obj = [[NSObject alloc] init];
    }
    dispatch_async(dispatch_get_main_queue(), ^{
        UILabel *label = [[UILabel alloc] initWithFrame:CGRectMake(0,LHeight*count , [UIScreen mainScreen].bounds.size.width, LHeight)];
        count ++;
        label.textColor  = [UIColor blackColor];
        label.textAlignment = NSTextAlignmentCenter;
        label.text = [NSString stringWithFormat:@"%d",count];
        [self.scrollView addSubview:label];
        self.scrollView.contentSize = CGSizeMake([UIScreen mainScreen].bounds.size.width, label.frame.origin.y+label.frame.size.height);
    });
}

static long long timerTime = 0;
static long long linkTime = 0;
static long long gcdTime = 0;

- (void)_recordTimer{
    long long ctimer = [self gs_getCurrentTimeToMilliSecond];
    NSLog(@"-----record--timer-->%f",(ctimer-timerTime)*1.0/1000);
    timerTime = ctimer;
}
- (void)_recordLink{
    long long clink = [self gs_getCurrentTimeToMilliSecond];
    NSLog(@"-----record--link-->%f",(clink-linkTime)*1.0/1000);
    linkTime = clink;
   
}
- (void)_recordGCD{
    long long cgcd = [self gs_getCurrentTimeToMilliSecond];
    NSLog(@"-----record--gcd-->%f",(cgcd-gcdTime)*1.0/1000);
    gcdTime = cgcd;
}
- (long long)gs_getCurrentTimeToMilliSecond {
    double currentTime = [[NSDate date] timeIntervalSince1970] * 1000;
    long long iTime = (long long)currentTime;
    return iTime;
}


- (void)_buttonClick:(UIButton *)btn{
    if (self.connectTimer) {
        dispatch_source_cancel(self.connectTimer);
          self.connectTimer = nil;
    }    self.testTimer = nil;
    
      [self dismissViewControllerAnimated:YES completion:nil];
}


- (void)dealloc{
    NSLog(@"---vc---dealloc------");
    NSLog(@"----viewdalloc----timer----->%@",self.testTimer);
    count = 0;
}


@end
